#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 

//define for VerySetFunction
#define Very_Set_Range						131
#define Very_Get_PdfPageCount			206
#define Very_Get_PageBoxForStamp	260
#define Very_Set_Text_Leading			134
#define Very_Set_Opacity					240
#define Very_Set_EmbedFont				241
#define Very_Get_EmbedFont				241
#define Very_Set_TransparentColor	242
		
typedef long	(__stdcall *VeryStampRegFunc)(char *reg);
typedef long	(__stdcall *VeryStampLayerOpenFunc)(char *In, char *Out, char *lpFGLayerName,char *lpBGLayerName);
typedef long	(__stdcall *VeryStampOpenFunc)(char *In,char *Out);
typedef void	(__stdcall *VeryStampCloseFunc)(long id);
typedef long	(__stdcall *VeryStampSetFunctionFunc)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *VeryStampGetFunctionFunc)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *VeryStampAddImageFunc)(long id,long position, 
												   char *filename,
												   long shift_lr,long shift_tb,long rotate,long layer,
												   long zoomW,long zoomH,
												   long action,char *link,long pageno);
typedef long	(__stdcall *VeryStampAddImageExFunc)(long id,long position, char *filename,
													 long shift_lr,long shift_tb,long rotate,long layer,
													 long width,long height,
													 long action,char *link,long pageno);
typedef long	(__stdcall *VeryStampAddTextFunc)(long id,long position, 
												  char *string, long color,long alignment,
												  long shift_lr,long shift_tb,long rotate,long layer,
												  long hollow, long fontcode,char *fontname,long fontsize,
												  long action,char *link,long pageno);

typedef long	(__stdcall *VeryStampAddLineFunc)(long id,long position, long width,long color,
												  long shift_lr,long shift_tb,long rotate,long layer,
												  long zoomW,long zoomH);
typedef long	(__stdcall *VeryStampAddRectFunc)(long id,long sx_,long sy_,long ex_,long ey_,
												  long side_width,long side_color,
												  long flagFill,long fill_color);
typedef long	(__stdcall *VeryStampAddCircleFunc)(long id,long x,long y, long radius,
													long side_width,long side_color,
													long flagFill,long fill_color);
typedef long	(__stdcall *VeryStampAddEllipseFunc)(long id,long sx_,long sy_,long ex_,long ey_,
													 long side_width,long side_color,
													 long flagFill,long fill_color);
typedef long	(__stdcall *VeryStampAddCurveToFunc)(long id,long sx_,long sy_,long x1,long y1,
													 long x2,long y2,long x3,long y3,
													 long side_width,long side_color);

typedef long	(__stdcall *VeryStampAddRectWithLayerFunc)(long id,long sx_,long sy_,long ex_,long ey_,
														   long side_width,long side_color,
														   long flagFill,long fill_color,long layer);
typedef long	(__stdcall *VeryStampUndoFunc)(char *filename);
typedef long	(__stdcall *VeryStampAddLineExFunc)(long id,long sx,long sy,long ex,long ey,long width,long color);
typedef long	(__stdcall *VeryStampIsStampedFunc)(char *lpPDFFile);

typedef long (__stdcall *VeryStampForm_AllocFunc)();
typedef long (__stdcall *VeryStampForm_FreeFunc)(long id);
typedef long (__stdcall *VeryStampForm_SetTextFieldFunc)(long id, LPCTSTR lpFieldName, LPCTSTR lpFieldValue);
typedef long (__stdcall *VeryStampForm_SetCheckBoxFunc)(long id, LPCTSTR lpFieldName, LPCTSTR lpFieldValue);
typedef long (__stdcall *VeryStampForm_ApplyFunc)(long id, LPCTSTR lpInFile, LPCTSTR lpOutFile, LONG bFlatten);
typedef long (__stdcall *VeryStampForm_ClearFieldsFunc)(long id);

typedef long (__stdcall *VeryStampEncryptPDFFunc)(LPSTR lpInPDF, LPSTR lpOutPDF,char *lpszOpenPwd,char *lpszOwnerPwd,
							int iKeyLen, int iRestriction);

HMODULE							g_hVeryW=NULL;

VeryStampRegFunc				VeryStampReg			= NULL;
VeryStampOpenFunc				VeryStampOpen			= NULL;
VeryStampLayerOpenFunc			VeryStampLayerOpen		= NULL;
VeryStampCloseFunc				VeryStampClose			= NULL;
VeryStampSetFunctionFunc		VeryStampSetFunction	= NULL;
VeryStampSetFunctionFunc		VeryStampGetFunction	= NULL;
VeryStampAddImageFunc			VeryStampAddImage		= NULL;
VeryStampAddImageExFunc			VeryStampAddImageEx		= NULL;
VeryStampAddTextFunc			VeryStampAddText		= NULL;
VeryStampAddLineFunc			VeryStampAddLine		= NULL;
VeryStampAddRectFunc			VeryStampAddRect		= NULL;
VeryStampAddRectWithLayerFunc	VeryStampAddRectWithLayer = NULL;
VeryStampUndoFunc				VeryStampUndo			= NULL;
VeryStampIsStampedFunc			VeryStampIsStamped		= NULL;
VeryStampAddLineExFunc			VeryStampAddLineEx		= NULL;
VeryStampAddCircleFunc			VeryStampAddCircle		= NULL;
VeryStampAddEllipseFunc			VeryStampAddEllipse		= NULL;
VeryStampAddCurveToFunc			VeryStampAddCurveTo		= NULL;

VeryStampForm_AllocFunc			VeryStampForm_Alloc			= NULL;
VeryStampForm_FreeFunc			VeryStampForm_Free			= NULL;
VeryStampForm_SetTextFieldFunc	VeryStampForm_SetTextField	= NULL;
VeryStampForm_SetCheckBoxFunc	VeryStampForm_SetCheckBox	= NULL;
VeryStampForm_ApplyFunc			VeryStampForm_Apply			= NULL;
VeryStampForm_ClearFieldsFunc	VeryStampForm_ClearFields	= NULL;

VeryStampEncryptPDFFunc			VeryStampEncryptPDF			= NULL;

typedef struct DLLFUNCtag{
	char *name1;
	char *name2;
	void **func;
}DLLFunc;
DLLFunc aryDLLFunc[] = {
	{"veryReg", "VeryStampReg", (void**)&VeryStampReg},
	{"veryOpen", "VeryStampOpen", (void**)&VeryStampOpen},
	{"veryClose", "VeryStampClose", (void**)&VeryStampClose},
	{"veryAddText", "VeryStampAddText", (void**)&VeryStampAddText},
	{"veryAddImage", "VeryStampAddImage", (void**)&VeryStampAddImage},
	{"veryAddImageEx", "VeryStampAddImageEx", (void**)&VeryStampAddImageEx},
	{"veryAddLine", "VeryStampAddLine", (void**)&VeryStampAddLine},
	{"veryAddLineEx", "VeryStampAddLineEx", (void**)&VeryStampAddLineEx},
	{"veryAddRect", "VeryStampAddRect", (void**)&VeryStampAddRect},
	{"verySetFunction", "VeryStampSetFunction", (void**)&VeryStampSetFunction},
	{"veryGetFunction", "VeryStampGetFunction", (void**)&VeryStampGetFunction},
	{"veryUndo", "VeryStampUndo", (void**)&VeryStampUndo},
	{"veryAddRectWithLayer", "VeryStampAddRectWithLayer", (void**)&VeryStampAddRectWithLayer},
	{"veryAddCircle", "VeryStampAddCircle", (void**)&VeryStampAddCircle},
	{"veryAddEllipse", "VeryStampAddEllipse", (void**)&VeryStampAddEllipse},
	{"veryAddCurveTo", "VeryStampAddCurveTo", (void**)&VeryStampAddCurveTo},
	{"VeryStampLayerOpen", "VeryStampLayerOpen", (void**)&VeryStampLayerOpen},
	{"veryIsStamped", "VeryStampIsStamped", (void**)&VeryStampIsStamped},
	{"VeryStampForm_Alloc", "VeryStampForm_Alloc", (void**)&VeryStampForm_Alloc},
	{"VeryStampForm_Free", "VeryStampForm_Free", (void**)&VeryStampForm_Free},
	{"VeryStampForm_SetTextField", "VeryStampForm_SetTextField", (void**)&VeryStampForm_SetTextField},
	{"VeryStampForm_SetCheckBox", "VeryStampForm_SetCheckBox", (void**)&VeryStampForm_SetCheckBox},
	{"VeryStampForm_Apply", "VeryStampForm_Apply", (void**)&VeryStampForm_Apply},
	{"VeryStampForm_ClearFields", "VeryStampForm_ClearFields", (void**)&VeryStampForm_ClearFields},
	{"VeryStampEncryptPDF", "VeryStampEncryptPDF", (void**)&VeryStampEncryptPDF},
};

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadVeryWDll(void);
void	FreeVeryWDll();

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadVeryWDll()
{
	int i;
	char path[_MAX_PATH];
	GetModulePath(path,"PdfStamp.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
	{
		GetModulePath(path,"verywrite.dll");
		g_hVeryW=LoadLibrary(path);
		if(g_hVeryW==NULL)
			goto Failer;
	}

	for(i = 0; i < sizeof(aryDLLFunc)/sizeof(DLLFunc); i++)
	{
		void *lpFunc = (void*)GetProcAddress(g_hVeryW,aryDLLFunc[i].name1);
		if(lpFunc == NULL)
			lpFunc = (void*)GetProcAddress(g_hVeryW,aryDLLFunc[i].name2);
		if(lpFunc)
			*aryDLLFunc[i].func = lpFunc;
		else
			goto Failer;
	}

	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;
}

void FreeVeryWDll()
{
	if(g_hVeryW==NULL)
		return ;
	FreeLibrary(g_hVeryW);
	g_hVeryW=NULL;
}


void PDFFormFilling()
{
	long id;
	int nRet = -1;
	char szOutPDF1[MAX_PATH];
	char szOutPDF2[MAX_PATH];
	char szPDFFile[MAX_PATH];
	GetModulePath(szPDFFile,"example-fw9.pdf");
	GetModulePath(szOutPDF1,"out1.pdf");
	GetModulePath(szOutPDF2,"out2.pdf");

	id = VeryStampForm_Alloc();
	nRet = VeryStampForm_SetTextField(id, "f1-1", "1 Test for Name");
	nRet = VeryStampForm_SetTextField(id, "f1-2", "1 Test for Business Name");
	nRet = VeryStampForm_SetTextField(id, "f1-3", "1 Test for f1-3");
	nRet = VeryStampForm_SetTextField(id, "f1-4", "1 Test for f1-4");
	nRet = VeryStampForm_SetTextField(id, "f1-5", "1 Test for f1-5");
	nRet = VeryStampForm_SetTextField(id, "f1-6", "1 Test for f1-6");
	nRet = VeryStampForm_SetCheckBox(id, "c1-4", "Off");
	nRet = VeryStampForm_SetCheckBox(id, "c1-5", "Off");
	nRet = VeryStampForm_SetCheckBox(id, "c1-1", "Yes");
	nRet = VeryStampForm_SetCheckBox(id, "c1-2", "Yes");
	nRet = VeryStampForm_Apply(id, szPDFFile, szOutPDF1, FALSE);
	nRet = VeryStampForm_ClearFields(id);
	nRet = VeryStampForm_SetTextField(id, "f1-1", "2 Test for Name");
	nRet = VeryStampForm_SetTextField(id, "f1-2", "2 Test for Business Name");
	nRet = VeryStampForm_SetTextField(id, "f1-3", "2 Test for f1-3");
	nRet = VeryStampForm_SetTextField(id, "f1-4", "2 Test for f1-4");
	nRet = VeryStampForm_SetTextField(id, "f1-5", "2 Test for f1-5");
	nRet = VeryStampForm_SetTextField(id, "f1-6", "2 Test for f1-6");
	nRet = VeryStampForm_SetCheckBox(id, "c1-4", "Off");
	nRet = VeryStampForm_SetCheckBox(id, "c1-5", "Off");
	nRet = VeryStampForm_SetCheckBox(id, "c1-1", "Yes");
	nRet = VeryStampForm_SetCheckBox(id, "c1-2", "Yes");
	nRet = VeryStampForm_Apply(id, szPDFFile, szOutPDF2, TRUE);
	nRet = VeryStampForm_Free(id);
}

void EmbedBarcodeFonts()
{
	long id;
	int nRet = -1;
	char szOutPDF[MAX_PATH];
	char szPDFFile[MAX_PATH];
	GetModulePath(szPDFFile,"example.pdf");
	GetModulePath(szOutPDF,"out-embedfont.pdf");

	id=VeryStampOpen(szPDFFile,szOutPDF);
	if(id>0)
	{
		VeryStampSetFunction(id, Very_Set_EmbedFont, 1, 0, 0, 0);
		VeryStampAddText(id, 1, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Free 3 of 9", 8, 1,"http://www.verypdf.com/",0);
		VeryStampAddText(id, 2, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Free 3 of 9,Bold", 8, 1,"http://www.verypdf.com/",0);
		VeryStampAddText(id, 3, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Free 3 of 9,Italic", 8, 1,"http://www.verypdf.com/",0);
		VeryStampAddText(id, 4, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Free 3 of 9,Italic,Bold", 8, 1,"http://www.verypdf.com/",0);
		VeryStampClose(id);
	}
}
void BoldItalicFonts()
{
	long id;
	int nRet = -1;
	char szOutPDF[MAX_PATH];
	char szPDFFile[MAX_PATH];
	GetModulePath(szPDFFile,"example.pdf");
	GetModulePath(szOutPDF,"out-BoldItalicFonts.pdf");
	
	id=VeryStampOpen(szPDFFile,szOutPDF);
	if(id>0)
	{
		VeryStampSetFunction(id, Very_Set_EmbedFont, 0, 0, 0, 0);
		VeryStampAddText(id, 1, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Arial", 8, 1,"http://www.verypdf.com/",0);
		VeryStampAddText(id, 2, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Arial,Bold", 8, 1,"http://www.verypdf.com/",0);
		VeryStampAddText(id, 3, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Arial,Italic", 8, 1,"http://www.verypdf.com/",0);
		VeryStampAddText(id, 4, "0123456789", RGB(0, 0, 0), 0, 0, 0, 0, 0, 0, 0, "Arial,Italic,Bold", 8, 1,"http://www.verypdf.com/",0);
		VeryStampClose(id);
	}
}
void TestForTextAlign()
{
	int id=VeryStampOpen("example.pdf","example-text-align.pdf");
	if(id>0)
	{
		char *sPropertyInfo = "Test Name\n123 Test Address\nHip Road\nTest Locality\nTest Town\nTest County\nGU52 2SD";
		VeryStampSetFunction(id, 131, 1, 1, "", "");
		VeryStampAddText(id, 1, sPropertyInfo, 0, 17, 192, 240, 0, 0, 0, 101, "", 16, 0, "", 0);
		VeryStampClose(id);
	}
}

void main(int argc,char* argv[])
{
	char szPDFFile[256];
	char szImageFile[256];
	long id;
	int iRet = 0;

	memset(szPDFFile,0,256);
	memset(szImageFile,0,256);

	if(!LoadVeryWDll())
		return;

	//Register PDFStamp SDK with your License Key
	VeryStampReg("XXXXXXXXXXXXXXXXXXXXXXXX");

	//Test for PDF Form Filling
	PDFFormFilling();
	EmbedBarcodeFonts();
	BoldItalicFonts();

	TestForTextAlign();
	GetModulePath(szPDFFile,"example.pdf");
		
	if(1)
	{
		//int pagecount = VeryStampGetFunction(id,206,0,0,0,0);
		//strcpy(szPDFFile,"C:\\temp\\pdfstamp_sdk_v1.1_full\\bin\\example.pdf");
		//strcpy(szImageFile,"C:\\_12_example.pdf");
		id=VeryStampOpen(szPDFFile,"_001.pdf");
		if(id>0)
		{
			int page = 1;
			int pagecount = VeryStampGetFunction(id, Very_Get_PdfPageCount, 0, 0, 0, 0);
			VeryStampSetFunction(id, Very_Set_Opacity, 50, 0, 0, 0);
			for(page = 1; page <= pagecount; page++)
			{
				char m_szStampBuf[1024];
				int left = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "left", 0);
				int top = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "top", 0);
				int pagewidth = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "width", 0);
				int pageheight = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "height", 0);

				VeryStampSetFunction(id, Very_Set_Range, page, 1, 0, 0);
				sprintf(m_szStampBuf,"Page:<%d>, Page Box: [%d %d %d %d]",pagecount-page+1,left,top,pagewidth,pageheight);
				VeryStampAddText(id, 2, m_szStampBuf,255,0,0,0,0,0,0,300,0,10,1,"http://www.verypdf.com",0);
				VeryStampSetFunction(id,Very_Set_Text_Leading,20,0,0,0);
				strcpy(m_szStampBuf,"2200444\n20555\n2200666\n2777");
				VeryStampAddText(id, 1, m_szStampBuf, 255,18,0,0,0,0,0,200,0,10,1,NULL,0);
			}
			VeryStampSetFunction(id, Very_Set_Range, 2, 2, 0,0);
			VeryStampSetFunction(id, Very_Set_Opacity, 30, 0, 0, 0);
			VeryStampAddImage(	id, 7, "logo.jpg",30,-30,0,0,0,0,0,0,0);
			VeryStampAddImage(	id, 3, "logo.jpg",-30,30,0,0,0,0,0,0,0);

			//Set page range, stamp on all pages
			VeryStampSetFunction(id, Very_Set_Range, 0, 0, 0,0);

			//Convert white color to transparent background
			VeryStampSetFunction(id, Very_Set_TransparentColor, 1, RGB(255,255,255), 0, 0);
			VeryStampAddImage(	id, 1, "logo.jpg",0,0,0,0,0,0,0,0,0);

			VeryStampAddRect(id, 100, 100, 150,150, 2, RGB(255,0,0),0,RGB(255,0,0));
			VeryStampAddRect(id, 100, 300, 150,350, 2, RGB(255,0,0),1,RGB(255,0,0));
			VeryStampAddRect(id, 100, 400, 150,450, 4, RGB(255,255,0),0,RGB(255,0,0));
			VeryStampAddRect(id, 100, 500, 150,550, 4, RGB(255,255,0),1,RGB(255,0,255));

			VeryStampAddCircle(id, 100, 300, 50, 20, RGB(255,0,0), 0, 0);
			VeryStampAddEllipse(id, 20, 20, 200, 80, 10, RGB(0,0,255), 0, 0);
			{
				int pageheight = 800;
				VeryStampAddCurveTo(id, 0, pageheight, 86, pageheight-108, 201, pageheight-158, 
					216, pageheight-86,	5,RGB(0,0,255));
			}
			
			VeryStampSetFunction(id, Very_Set_Opacity, 70, 0, 0, 0);
			VeryStampAddLine(	id, 2, 1, RGB(255,0,0),
						0,80,0,0,
						80,0);
			VeryStampAddLine(	id, 6, 1, RGB(0,255,0),
						0,-80,0,0,
						80,0);
			VeryStampSetFunction(id, Very_Set_Opacity, 25, 0, 0, 0);
			VeryStampAddRectWithLayer(id, 200, 100, 250,150, 2, RGB(255,0,0),0,RGB(255,0,0),1);
			VeryStampAddRectWithLayer(id, 200, 300, 250,350, 2, RGB(255,0,0),1,RGB(255,0,0),1);
			VeryStampAddRectWithLayer(id, 200, 400, 250,450, 4, RGB(255,255,0),0,RGB(255,0,0),1);
			VeryStampAddRectWithLayer(id, 200, 500, 250,550, 4, RGB(255,255,0),1,RGB(255,0,255),1);

			VeryStampClose(id);
		}
		CopyFile("_001.pdf","_001_undo.pdf",FALSE);
		VeryStampUndo("_001_undo.pdf");

		iRet = VeryStampIsStamped("_001.pdf");
		iRet = VeryStampIsStamped(szPDFFile);
		iRet = VeryStampIsStamped("_001_undo.pdf");

		iRet = VeryStampEncryptPDF("_001.pdf", "_001-encrypted.pdf", "123", "456", 2, 3900);
	}
	//%text stamp%
	//%page header and page footer%
	//%Stamps are placed in the duplicate file, leaving the original copy unchanged%
	id=VeryStampOpen(szPDFFile,"1.pdf");
	if(id>0){
		VeryStampAddText(	id, 7, 
						"\\d\\n\\t",
						255,0,
						50,-30,0,0,
						0,
						0,0,10,
						0,0,0);
		VeryStampAddText(	id, 5, 
						"Page \\P3+1 of \\c",
						255,0,
						-50,-30,0,0,
						0,
						0,0,10,
						0,0,0);
		VeryStampAddText(	id, 3, 
						"2003 verypdf.com Inc.",
						2666666,0,
						-30,30,	0,0,
						0,
						300,0,10,
						0,0,0);
		VeryStampClose(id);
	}

	//%.Supports Font Style, Font Size, Text Modes (solid, outline), Grayscale and RGB Color (0-255 RGB color values supported) %
	//%.Top, bottom, vertical center, diagonal-top left and diagonal-bottom left. %
	//%Supports multiple line text stamps within one stamp item %	
	id=VeryStampOpen(szPDFFile,"2.pdf");
	if(id>0){
		VeryStampAddText(	id, 3, 
						"Sample File\\nVerypdf",
						0,0,
						0,0,0,0,
						0,
						300,0,0,
						0,0,0);
		VeryStampAddText(	id, 6, 
						"Copyright verypdf.com, Inc.",
						RGB(255,200,100),0,
						0,0,0,0,
						0,
						0,0,0,
						0,0,0);
		VeryStampAddText(	id, 9, 
						"www.verypdf.com\\n Demo",
						255,0,
						0,0,-45,0,
						1,
						200,0,48,
						0,0,0);
		VeryStampClose(id);
	}

	//%.Grayscale Color (0-255 RGB color values supported) %
	//%.diagonal-top left and diagonal-bottom left. %
	//%Stamp on Top of or Underneath the original PDF document page contents %
	//Justification (when multi text)- Left, right, or center
	id=VeryStampOpen(szPDFFile,"3.pdf");
	if(id>0){
		VeryStampAddText(	id, 5, 
						"Page \\p of \\c",
						0,0,
						0,0,0,0,
						0,
						0,0,10,
						0,0,0);
		VeryStampAddText(	id, 9, 
						"www.verypdf.com\\n Demo",
						RGB(200,200,200),18,
						0,0,-45,1,
						0,
						301,0,48,
						0,0,0);
		VeryStampClose(id);
	}

	//%Supports Font Style, Font Size, Text Modes (solid, outline), Grayscale and RGB Color (0-255 RGB color values supported) %
	//%Stamp on Underneath the original PDF document page contents %
	//%Text and Image can be stamped on any angle. Any positive or negative numbers, including decimal numbers may be used to specify an angle in degrees %
	id=VeryStampOpen(szPDFFile,"4.pdf");
	if(id>0){
		VeryStampAddText(	id, 9, 
						"www.verypdf.com",
						RGB(200,200,200),0,
						0,0,-20,1,
						1,
						202,0,60,
						0,0,0);
		VeryStampClose(id);
	}

	//%Stamps can be placed in the exact vertical center of a page (or the exact vertical center within a individual stamping space) %
	id=VeryStampOpen(szPDFFile,"5.pdf");
	if(id>0){
		VeryStampAddText(	id, 9, 
						"www.verypdf.com",
						RGB(255,255,0),0,
						0,0,0,0,
						0,
						101,0,48,
						0,0,0);
		VeryStampAddText(	id, 8, 
						"www.verypdf.com",
						RGB(0,255,255),0,
						0,0,90,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 4, 
						"www.verypdf.com",
						RGB(0,255,255),0,
						0,0,-90,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampClose(id);
	}

	//tridimensional effect
	id=VeryStampOpen(szPDFFile,"6.pdf");
	if(id>0){
		VeryStampAddText(	id, 9, 
						"www.verypdf.com",
						RGB(64,64,64),0,
						1,1,45,0,
						0,
						0,0,64,
						0,0,0);
		VeryStampAddText(	id, 9, 
						"www.verypdf.com",
						RGB(255,0,0),0,
						0,0,45,0,
						0,
						0,0,64,
						0,0,0);
		VeryStampClose(id);
	}

	//hollow tridimensional effect
	id=VeryStampOpen(szPDFFile,"7.pdf");
	if(id>0){
		VeryStampAddText(	id, 9, 
						"www.verypdf.com",
						RGB(64,64,64),0,
						1,2,45,1,
						1,
						0,0,64,
						0,0,0);
		VeryStampAddText(	id, 9, 
						"www.verypdf.com",
						RGB(255,0,0),0,
						0,0,45,0,
						1,
						0,0,64,
						0,0,0);
		VeryStampClose(id);
	}

	//%Supports image stamp (JPEG/TIFF images) %
	id=VeryStampOpen(szPDFFile,"8.pdf");
	if(id>0){
		VeryStampAddImage(	id, 7, 
						"logo.jpg",
						30,-30,0,0,
						0,0,
						0,0,0);
		VeryStampAddImage(	id, 3, 
						"logo.jpg",
						-30,30,0,0,
						0,0,
						0,0,0);
		VeryStampClose(id);
	}

	//% image stamp  %
	//%vertical center.%
	id=VeryStampOpen(szPDFFile,"9.pdf");
	if(id>0){
		VeryStampAddImage(	id, 4, 
						"logo.jpg",
						-10,0,90,0,
						0,0,
						0,0,0);
		VeryStampAddImage(	id, 8, 
						"logo.jpg",
						10,0,-90,0,
						0,0,
						0,0,0);
		VeryStampClose(id);
	}

	//%	Wrap text to a new line if it would otherwise be too long to fit in its margined area%
	id=VeryStampOpen(szPDFFile,"10.pdf");
	if(id>0){
		VeryStampAddText(	id, 9, 
						"Wrap text to a new line if it would otherwise be too long to fit in its margined area.",
						2666666,16,
						0,0,0,1,
						0,
						0,0,64,
						0,0,0);
		VeryStampClose(id);
	}

	//%Supports web links%
	//%Enabling you to easily position the stamp in any location on the page %
	id=VeryStampOpen(szPDFFile,"11.pdf");
	if(id>0){
		VeryStampAddText(	id, 2, 
						"Supports web links",
						RGB(255,11,0),0,
						-50,200,0,1,
						0,
						0,0,48,
						1,"http://www.verypdf.com",0);
		VeryStampAddText(	id, 4, 
						"Enabling you to easily position the stamp\\n in any location on the page",
						RGB(255,11,22),17,
						-50,200,0,0,
						0,
						0,0,10,
						1,"http://www.verypdf.com",0);
		VeryStampClose(id);
	}

	//%text rotate and position%
	id=VeryStampOpen(szPDFFile,"12.pdf");
	if(id>0){
		VeryStampAddText(	id, 1, 
						"verypdf.com Inc.",
						65296,0,
						0,0,-45,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 3, 
						"verypdf.com Inc.",
						65296,0,
						0,0,45,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 5, 
						"verypdf.com Inc.",
						65296,0,
						0,0,-45,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 7, 
						"verypdf.com Inc.",
						65296,0,
						0,0,45,0,
						0,
						0,0,48,
						0,0,0);

		VeryStampClose(id);
	}

	//%image rotate and position%
	id=VeryStampOpen(szPDFFile,"13.pdf");
	if(id>0){
		VeryStampAddImage(	id, 9, 
						"logo.jpg",
						-70,-70,-45,0,
						0,0,
						0,0,0);

		VeryStampAddImage(	id, 9, 
						"logo.jpg",
						70,-70,225,0,
						0,0,
						0,0,0);
		VeryStampAddImage(	id, 9, 
						"logo.jpg",
						70,70,135,0,
						0,0,
						0,0,0);
		VeryStampAddImage(	id, 9, 
						"logo.jpg",
						-70,70,45,0,
						0,0,
						0,0,0);

		VeryStampClose(id);
	}
	
	id=VeryStampOpen(szPDFFile,"14.pdf");
	if(id>0){
		VeryStampAddText(	id, 7, 
						"verypdf.com Inc.",
						165296,0,
						0,-100,-45,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 7, 
						"verypdf.com Inc.",
						1652962,0,
						50,-200,-45,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 7, 
						"verypdf.com Inc.",
						16529621,0,
						100,-300,-45,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 7, 
						"verypdf.com Inc.",
						165296210,0,
						150,-400,-45,0,
						0,
						0,0,48,
						0,0,0);
		VeryStampAddText(	id, 7, 
						"verypdf.com Inc.",
						165210,0,
						200,-500,-45,0,
						0,
						0,0,48,
						0,0,0);

		VeryStampClose(id);
	}

	//%image zoom%
	id=VeryStampOpen(szPDFFile,"15.pdf");
	if(id>0){
		VeryStampAddImage(	id, 2, 
						"logo.jpg",
						80,200,-45,1,
						300,300,
						0,0,0);
		VeryStampClose(id);
	}


	//%Supports line stamp  %
	id=VeryStampOpen(szPDFFile,"16.pdf");
	if(id>0){
		VeryStampAddText(	id, 7, 
						"\\d\\n\\t",
						255,0,
						70,-50,0,0,
						0,
						0,0,10,
						0,0,0);
		VeryStampAddText(	id, 5, 
						"Page \\p of \\c ",
						255,0,
						-70,-50,0,0,
						0,
						0,0,10,
						0,0,0);
		VeryStampAddText(	id, 3, 
						"2003 verypdf.com Inc.",
						255,0,
						-60,60,0,0,
						0,
						300,0,10,
						0,0,0);

		VeryStampAddLine(	id, 2, 1, 0,
						0,80,0,0,
						80,0);
		VeryStampAddLine(	id, 6, 1, 0,
						0,-80,0,0,
						80,0);

		VeryStampClose(id);
	}

		

	//%Supports links (web links, page link, open file, remote page link).%
	id=VeryStampOpen(szPDFFile,"17.pdf");
	if(id>0){
		
		VeryStampAddText(	id, 2, 
						"Supports web links",
						255,0,
						-50,200,15,0,
						0,
						0,0,32,
						1,"http://www.verypdf.com",0);
		
		VeryStampAddText(	id, 4, 
						"Supports page links",
						255,0,
						-50,200,0,0,
						0,
						0,0,32,
						2,0,3);

		
		VeryStampAddImage(	id, 9, 
						"logo.jpg",
						0,0,15,1,
						0,0,
						3,"openlink.txt",0);
		
		VeryStampClose(id);
	}



	//%Set which pages to stamp on by selecting a predefined range.%
	//%	Every even page%
	id=VeryStampOpen(szPDFFile,"18.pdf");
	if(id>0){
		//%	Every even page%
		VeryStampSetFunction(id, Very_Set_Range, -2, -2, 0,0);
 
		VeryStampAddText(	id, 2, 
						"Set which pages to stamp on by selecting a predefined range.",
						2666666,17,
						0,200,0,0,
						0,
						0,0,32,
						0,0,0);
		VeryStampAddRect(id, 100, 100, 150,150, 2, RGB(255,0,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 300, 150,350, 2, RGB(255,0,0),1,RGB(255,0,0));
		VeryStampAddRect(id, 100, 400, 150,450, 4, RGB(255,255,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 500, 150,550, 4, RGB(255,255,0),1,RGB(255,0,255));

		VeryStampClose(id);
	}
	
	id=VeryStampLayerOpen(szPDFFile,"newlayer.pdf", "FGLayerName", "BGLayerName");
	if(id>0){
		VeryStampAddText(	id, 2, 
						"VeryPDF Layer Stamper",
						2666666,17,
						0,200,0,0,
						0,
						0,0,32,
						0,0,0);
		VeryStampAddRect(id, 100, 100, 150,150, 2, RGB(255,0,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 300, 150,350, 2, RGB(255,0,0),1,RGB(255,0,0));
		VeryStampAddRect(id, 100, 400, 150,450, 4, RGB(255,255,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 500, 150,550, 4, RGB(255,255,0),1,RGB(255,0,255));

		VeryStampClose(id);
	}

	FreeVeryWDll();
}
